// Where the database is kept. Only used by Lookup.ServiceImpl to retrieve info
// from the data base and send it to the client.
// Author: ???
unit Database;

interface

uses
  System.SysUtils, System.Classes, Data.DB, MemDS, DBAccess, Uni, UniProvider,
  PostgreSQLUniProvider, System.Variants, System.Generics.Collections, System.IniFiles,
  Common.Logging, Vcl.Forms, MySQLUniProvider;

type
  TFDatabaseModule = class(TDataModule)
    ucKG: TUniConnection;
    UniQuery1: TUniQuery;
    MySQLUniProvider1: TMySQLUniProvider;
    UniQuery2: TUniQuery;
    uqOrders: TUniQuery;
    uqOrdersORDER_ID: TIntegerField;
    uqOrdersCOMPANY_ID: TIntegerField;
    uqOrdersUSER_ID: TIntegerField;
    uqOrdersORDER_DATE: TDateTimeField;
    uqOrdersSTART_DATE: TDateField;
    uqOrdersEND_DATE: TDateField;
    uqOrdersORDER_STATUS: TStringField;
    uqOrdersSCHED_JSON: TStringField;
    uqOrdersstaff_fields_order_date: TDateField;
    uqOrdersstaff_fields_proof_date: TDateField;
    uqOrdersstaff_fields_ship_date: TDateField;
    uqOrdersstaff_fields_ship_via: TStringField;
    uqOrdersstaff_fields_price: TStringField;
    uqOrdersstaff_fields_invoice_to: TStringField;
    uqOrdersstaff_fields_invoice_attention: TStringField;
    uqOrdersstaff_fields_ship_to: TStringField;
    uqOrdersstaff_fields_ship_attention: TStringField;
    uqOrdersstaff_fields_po_number: TStringField;
    uqOrdersstaff_fields_job_name: TStringField;
    uqOrdersstaff_fields_art_due: TDateField;
    uqOrdersstaff_fields_plate_due: TDateField;
    uqOrdersstaff_fields_mount_due: TDateField;
    uqOrdersplates_job_number: TStringField;
    uqOrderssupplied_by_customer_b_w_copy: TStringField;
    uqOrderssupplied_by_customer_color_copy: TStringField;
    uqOrderssupplied_by_customer_plates: TStringField;
    uqOrderssupplied_by_customer_sample_ca: TStringField;
    uqOrderssupplied_by_customer_dimension: TStringField;
    uqOrderssupplied_by_customer_disk_or_cd: TStringField;
    uqOrderssupplied_by_customer_e_mail: TStringField;
    uqOrderssupplied_by_customer_ftp: TStringField;
    uqOrderssupplied_by_customer_other: TStringField;
    uqOrderssupplied_by_customer_existing_: TStringField;
    uqOrderssupplied_by_customer_ref_art_p: TStringField;
    uqOrderssupplied_by_customer_ref_art_a: TStringField;
    uqOrderscut_die_cutdier: TStringField;
    uqOrderscut_die_cutdieb: TStringField;
    uqOrderscut_die_cutdief: TStringField;
    uqOrderscut_die_cutdierkr: TStringField;
    uqOrderscut_die_cutdiefkr: TStringField;
    uqOrderscut_die_cad_file: TStringField;
    uqOrderscut_die_attached: TStringField;
    uqOrderscut_die_boxpol250: TStringField;
    uqOrderscut_die_boxpol155: TStringField;
    uqOrderscut_die_boxpol125: TStringField;
    uqOrderscut_die_brub: TStringField;
    uqOrdersproofing_fax: TStringField;
    uqOrdersproofing_fax_attn: TStringField;
    uqOrdersproofing_e_mail: TStringField;
    uqOrdersproofing_e_mail_attn: TStringField;
    uqOrdersproofing_ship_to: TStringField;
    uqOrdersproofing_full_size_panel: TStringField;
    uqOrdersproofing_print_card: TStringField;
    uqOrdersproofing_wide_format: TStringField;
    uqOrdersproofing_pdf_file: TStringField;
    uqOrdersproofing_other: TStringField;
    uqOrdersproofing_art_approved_as_is: TStringField;
    uqOrdersproofing_approved_date: TDateField;
    uqOrdersproofing_changes_required: TStringField;
    uqOrdersproofing_changes_date: TDateField;
    uqOrderslayout_rsc_l: TStringField;
    uqOrderslayout_rcs_w: TStringField;
    uqOrderslayout_rcs_d: TStringField;
    uqOrderslayout_die_cut_no: TStringField;
    uqOrderslayout_accross_no: TStringField;
    uqOrderslayout_around_no: TStringField;
    uqOrderslayout_cad_file: TStringField;
    uqOrderslayout_excalibur_die: TStringField;
    uqOrdersmounting_loose: TStringField;
    uqOrdersmounting_sticky_bak: TStringField;
    uqOrdersmounting_full_mount: TStringField;
    uqOrdersmounting_strip_mount: TStringField;
    uqOrderscolors_cylinder_size: TStringField;
    uqOrderscolors_machine_ident: TStringField;
    uqOrdersmounting_standard_setup: TStringField;
    uqOrdersmounting_custom_backing: TStringField;
    uqOrdersmounting_custom_adhesive: TStringField;
    uqOrderscolors_cross_hairs: TStringField;
    uqOrderscolors_clemson: TStringField;
    uqOrdersplates_thickness: TStringField;
    uqOrdersplates_plate_material: TStringField;
    uqOrdersgeneral_special_instructions: TStringField;
    uqOrderscolors_colors: TStringField;
    uqOrdersstaff_fields_quickbooks_item: TStringField;
    uqOrdersstaff_fields_quantity: TStringField;
    uqOrderslayout_rsc_style: TStringField;
    uqOrdersstaff_fields_art_location: TStringField;
    procedure DataModuleCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    class procedure ExecSQL(const SQL: string);
  end;

var
  FDatabaseModule: TFDatabaseModule;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

procedure TFDatabaseModule.DataModuleCreate(Sender: TObject);
// Sets the database connection to the ini file IP
// TODO: clean up unnecessary reads from the ini file
var
  IniFile: TIniFile;
  iniStr: string;
begin
  IniFile := TIniFile.Create( ChangeFileExt(Application.ExeName, '.ini') );
  try
    iniStr := IniFile.ReadString( 'Database', 'Server', '' );
    if iniStr.IsEmpty then
      Logger.Log( 1, 'iniFile: ' + ChangeFileExt(Application.ExeName, '.ini') +
                  ' Database->Server: Entry not found' )
    else
    begin
      Logger.Log( 1, 'iniFile: ' + ChangeFileExt(Application.ExeName, '.ini') +
                  ' Database->Server: ' + iniStr );
      ucKG.Server := iniStr;
    end;

    iniStr := IniFile.ReadString( 'Twilio', 'AccountSID', '' );
    if iniStr.IsEmpty then
      Logger.Log( 1, 'iniFile: ' + ChangeFileExt(Application.ExeName, '.ini') +
                  ' Twilio->AccountSID: Entry not found' )
    else
    begin
      Logger.Log( 1, 'iniFile: ' + ChangeFileExt(Application.ExeName, '.ini') +
                  ' Twilio->AccountSID: ' + iniStr );
      //accountSID := iniStr;
    end;

    iniStr := IniFile.ReadString( 'Twilio', 'AuthHeader', '' );
    if iniStr.IsEmpty then
      Logger.Log( 1, 'iniFile: ' + ChangeFileExt(Application.ExeName, '.ini') +
                  ' Twilio->AuthHeader: Entry not found' )
    else
    begin
      Logger.Log( 1, 'iniFile: ' + ChangeFileExt(Application.ExeName, '.ini') +
                  ' Twilio->AuthHeader: ' + iniStr );
      //authHeader := iniStr;
    end;
    Logger.Log(1, '');
  finally
    IniFile.Free;
  end;
end;

class procedure TFDatabaseModule.ExecSQL(const SQL: string);
var
  DB: TFDatabaseModule;
begin
  DB := TFDatabaseModule.Create(nil);
  try
    DB.UniQuery1.SQL.Text := SQL;
    DB.UniQuery1.ExecSQL;
  finally
    DB.Free;
  end;
end;

end.
